/*

  MINIGUI - Harbour Win32 GUI library Demo/Sample
 
  Copyright 2002-08 Roberto Lopez <harbourminigui@gmail.com>
 
  MsgExtTest.prg is a Freevare test program for MsgExtended() function.
  Also demonstrate using some handy HMG functions and commands.
  
  All bug reports and suggestions are welcome.
    
  Developed under Harbour Compiler and 
  MINIGUI - Harbour Win32 GUI library (HMG);
  compiled and linked by MinGW. 
  
  Thanks to "Le Roy" Roberto Lopez.
 
  All modules in the MsgExtended.prg and MExTest.prg 
  copyrighted : 2008 Bicahi Esgici <esgici@gmail.com>
 
  History :
  
     2008.08 : First Release
*/


#include <minigui.ch>

#define NTrim( n ) ( LTRIM( STR( n ) ) )

#translate ISNIL(  <xVal> ) => ( <xVal> == NIL )
#translate ISARRY( <xVal> ) => ( VALTYPE( <xVal> ) == "A" )
#translate ISCHAR( <xVal> ) => ( VALTYPE( <xVal> ) == "C" )
#translate ISNUMB( <xVal> ) => ( VALTYPE( <xVal> ) == "N" )


PROC Main()                               // Multiple message boxs for testing by sample

   LOCA nParam   :=  0,;
        c1Label  := "",;
        c1LblNam := "",;
        c1txbNam := ""

   SET DATE TO GERM
   SET CENT ON

   PRIV aParNames, aMsgSamples, aSamples

   MakSamples()

   DEFINE WINDOW frmMOptsTest ;
      AT     0,0 ;
      WIDTH  400 ;
      HEIGHT 450 ;
      MAIN       ;
      TITLE  "Tests for f.MsgExtended()"  ;
      ON INIT SetSmpVals( frmMOptsTest.cbxSamples.value )

      ON KEY ESCAPE ACTION frmMOptsTest.Release

      DEFINE COMBOBOX cbxSamples
         ROW 50
         COL 50
         WIDTH   200
         HEIGHT  180
         VALUE   5
         ON CHANGE SetSmpVals( this.value )
         ITEMS  aSamples

      END COMBOBOX // cbxSamples

      DEFINE FRAME fraSamples
          ROW 30
          COL 40
          CAPTION "  Samples "
          WIDTH 220
          HEIGHT 50
      END FRAME // fraSamples

      FOR nParam  := 1 TO LEN( aParNames )

         c1Label  := aParNames[ nParam ]
         c1LblNam := "lbl" + PADL( nParam, 2, "0" )

         DEFINE LABEL &c1LblNam
            ROW        103 + ( nParam - 1 ) * 30
            COL        45
            WIDTH      100
            VALUE      c1Label
            RIGHTALIGN .T.
         END LABEL // &c1LblNam

         c1txbNam := "txb" + PADL( nParam, 2, "0" )

         DEFINE TEXTBOX &c1txbNam
            ROW     100 + ( nParam - 1 ) * 30
            COL     150
            WIDTH   200
            HEIGHT  20
         END TEXTBOX // &c1txbNam

      NEXT nParam

      DEFINE BUTTON btnSampAply
         ROW 50
         COL 300
         WIDTH   40
         HEIGHT  20
         CAPTION 'Apply'
         ACTION  TstSamples( frmMOptsTest.cbxSamples.Value )
      END BUTTON // btnSampAply

      DEFINE FRAME fraParams
          ROW 85
          COL 40
          CAPTION "  Parameters  "
          WIDTH 320
          HEIGHT 315
      END FRAME // fraParams

   END WINDOW // frmMOptsTest

   CENTER WINDOW   frmMOptsTest
   ACTIVATE WINDOW frmMOptsTest

RETU // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.


PROC MakSamples()                         // Make sample datas for testing f.MsgExtended()

   LOCA nSample  := {},;
        a1MesLn  := {},;
        a1Option := {},;
        x1MesLn,;
        x1Option

   aSamples  := { "Without any parameter",;               //  1
                  "Without title",;                       //  2
                  "Without mesaj",;                       //  3
                  "Only mesaj",;                          //  4
                  "No mesaj, multiple options",;          //  5
                  "Simple message",;                      //  6
                  "Message with expressions - 1",;        //  7
                  "Famous Message",;                      //  8
                  "Two lines, two options",;              //  9
                  "Multiple Options",;                    // 10
                  "Single Line, multiple options",;       // 11
                  "Message with expressions - 2",;        // 12
                  "Different back color - 1",;            // 13
                  "Different back color - 2",;            // 14
                  "Different Font Size" }                 // 15

   aMsgSamples := { {},;                                                            //  1
                    { "Without Title" },;                                           //  2
                    {  , "Without mesaj" },;                                        //  3
                    { "Only one line message", "Only mesaj" },;                     //  4
                    { , "Column Selected", ;
                       {"Sort on this column","Hide Column","Ignore"} },;           //  5
                    { "This is message line", "Simple message", "Ok" },;            //  6
                    { DATE(), "Type is 'D'" },;                                     //  7
                    { "An undeterminable error occured",;                           //  8
                               "Famous Message",;
                               "Abort;;Retry;;Fail;;Ignore;;Cancel" },;
                    { { "Exit command requested",;                                  //  9
                               "Are you sure to quit ?" },;
                               "Two lines, two options",;
                             { "No, Continue",;
                               "Yes, Quit" } },;
                    { { "This file hase been modified.",;                           // 10
                                 "Save it before close ? " },;
                                 "Multiple Options",;
                               { "Save and Close",;
                                 "Close without save",;
                                 "Save, don't Close",;
                                 "Cancel Close Command" } },;
                    { { "Who is your favorite ?" },;                                // 11
                                 "Single Line, multiple options",;
                               { "Bart Simpson",;
                                 "Maradona" ,;
                                 "Don Quichote de La Mancha",;
                                 "C. Rice (Blackwitch)" ,;
                                 "G.W.Bush" } },;
                    { { "Today is:", DTOC(DATE()) + " " + CDOW(DATE()),;            // 12
                                  "90 day before is:",;
                                  DTOC(DATE() - 90) + " " + CDOW(DATE() - 90),;
                                  "2 * 2 = 4 is " + Any2Strg( 2 * 2 = 4 ),;
                                  "2 * 2 = 5 is " + Any2Strg( 2 * 2 = 5 ) },;
                                  "Message with expressions",;
                               { "Ok", "What is the matter?" } } }

   AADD( aMsgSamples, ACLONE( aMsgSamples[ 10 ] ) )                                 // 13
   aMsgSamples[ 13, 2 ] := "Different back color - 1"
   AADD( aMsgSamples[ 13 ], { 201, 215, 228 }  )  // grayed blue

   AADD( aMsgSamples, ACLONE( aMsgSamples[ 10 ] ) )                                 // 14
   aMsgSamples[ 14, 2 ] := "Different back color - 2"
   AADD( aMsgSamples[ 14 ], { 24, 240, 223 } )    // pastel turkuaz

   AADD( aMsgSamples, ACLONE( aMsgSamples[ 9 ] ) )                                  // 15
   aMsgSamples[ 15, 2 ] := "Different Font Size"
   AADD( aMsgSamples[ 15 ], NIL )  // Back color: default
   AADD( aMsgSamples[ 15 ], NIL )  // Message Font name: default
   AADD( aMsgSamples[ 15 ], 11 )   // Message Font Size
   AADD( aMsgSamples[ 15 ], NIL )  // Message Font color: default
   AADD( aMsgSamples[ 15 ], NIL )  // Opts. Font name: default
   AADD( aMsgSamples[ 15 ], 9)     // Opts. Font size
   AADD( aMsgSamples[ 15 ], { 0,8 } )    // Position


   FOR nSample := 1 TO LEN( aMsgSamples )

      IF !EMPTY( aMsgSamples[ nSample ] )

         x1MesLn  := aMsgSamples[ nSample, 1 ]

         IF !ISARRY( x1MesLn )                           // If isn't convert to array
            x1MesLn := { Any2Strg( x1MesLn )  }
         ENDIF

         a1MesLn := ParsArStr( x1MesLn  )                // CRLF Evaluation for Messages lines

         x1MesLn := ACLONE( a1MesLn )
         a1MesLn := {}

         a1MesLn := ParsArStr( x1MesLn, ";;" )        // Double Semicolon Evaluation for Messages lines

         aMsgSamples[ nSample, 1 ] := a1MesLn

      ENDIF !EMPTY( aMsgSamples[ nSample ]

      IF LEN( aMsgSamples[ nSample ] ) > 2

         x1Option := aMsgSamples[ nSample, 3 ]

         IF !ISARRY( x1Option )                           // If isn't convert to array
            x1Option := { Any2Strg( x1Option )  }
         ENDIF

         a1Option := ParsArStr( x1Option )                // CRLF Evaluation for Options

         x1Option := ACLONE( a1Option )
         a1Option := {}

         a1Option := ParsArStr( x1Option, ";;" )       // Double Semicolon Evaluation for Options

         aMsgSamples[ nSample, 3 ] := a1Option

      ENDIF LEN( aMsgSamples[ nSample ] ) > 2

   NEXT nSample

   aParNames := { "Message Lines",;           //  1
                  "Box Title",;               //  2
                  "Options",;                 //  3
                  "BackColor",;               //  4
                  "Msg. Font Name",;          //  5
                  "Msg. Font Size",;          //  6
                  "Msg. Font Color",;         //  7
                  "Opts. FontName",;          //  8
                  "Opts. Font Size",;         //  9
                  "Position" }                // 10


RETU // MakSamples()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.



PROC SetSmpVals( ;                        // Set sample text box values           
              nSampleNo )

   LOCA aTstPars := aMsgSamples[ nSampleNo ]

   LOCA nParamCo  := LEN( aTstPars ),;
        nTxtBoxNo :=  0,;
        cTxtBxNam := '',;
        cTempStrg := '',;
        xTxtBxVal 
        
   FOR nTxtBoxNo := 1 TO LEN( aParNames )
      xTxtBxVal := IF( nTxtBoxNo <= nParamCo, aTstPars[ nTxtBoxNo ], "" )
      
      IF ISARRY( xTxtBxVal )
         cTempStrg := ''
         AEVAL( xTxtBxVal, { | x1, i1 | cTempStrg += IF( i1 > 1, IF( ISNUMB( x1 ), ",", ";;" ), "" ) + Any2Strg( x1 ) } )                
         xTxtBxVal := cTempStrg 
      ENDIF
      
      cTxtBxNam  := "txb" + STRZERO( nTxtBoxNo, 2 )
      
      SetProperty ( "frmMOptsTest", cTxtBxNam, "VALUE", Any2Strg( xTxtBxVal ) )
      
   NEXT nParamNo 

RETU // SetSmpVals()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROC GetSmpVals( ;                        // Get sample text box values           
              nSampleNo )

   LOCA nParamCo  := LEN( aParNames ),;
        nTxtBoxNo :=  0,;
        cTxtBxNam := '',;
        aTemp     := {},;
        xTxtBxVal 
        
   FOR nTxtBoxNo := 1 TO nParamCo
   
      cTxtBxNam := "txb" + STRZERO( nTxtBoxNo, 2 )
      xTxtBxVal := GetProperty ( "frmMOptsTest", cTxtBxNam, "VALUE" )
      AADD( aTemp, xTxtBxVal )      
      
   NEXT nParamNo 
  
   aMsgSamples[ nSampleNo ] := aTemp
   
RETU // GetSmpVals()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
   

PROC TstSamples(;                         // Apply test for one sample
              nSampleNo )

   LOCA aTstPars  := {},;
        nParamCo  :=  0,;
        nParamNo  := 0,;
        cParName  := '',;
        nSelected :=  0,;
        cSelected := '',;
        nTxtBoxNo :=  0,;
        cTxtBxNam := '',;
        aOptions  := {},;
        xTxtBxVal 
        
   GetSmpVals( nSampleNo )

   aTstPars := aMsgSamples[ nSampleNo ]
   aOptions := ParsArStr( aTstPars[ 3 ], { CRLF, ";;" } )                
  
   nParamCo  := LEN( aTstPars )
        
   PRIV xParam1, xParam2, xParam3, xParam4, xParam5, xParam6, xParam7, xParam8, xParam9, xParam10

   FOR nParamNo := 1 TO nParamCo
      cParName  := "xParam" + NTrim( nParamNo )
      &cParname := aTstPars[ nParamNo ]
   NEXT nParamNo

   nSelected := MsgExtended( xParam1, xParam2, xParam3, xParam4, xParam5, xParam6, xParam7, xParam8, xParam9, xParam10 )
   
   IF nSelected < 1 
      cSelected := "Escaped"
   ELSEIF LEN( aOptions ) < 2
      cSelected := "Confirmed"
   ELSE
      cSelected := aOptions[ nSelected ] + CRLF + CRLF + "selected."
   ENDIF

   MsgInfo( cSelected, "RESULT" )

   frmMOptsTest.cbxSamples.SetFocus

RETU // TstSamples()


*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
   

* #include "MsgExtended.prg" 
